;  A simple effects routine - scrolls the screen clear to the left
;		--By Levi Lansing--
;       --Email ME! puzzlesome@hotmail.com
;You are free to do as you wish with this program EXCEPT you may
;  not put your name on it and call it your own!  DUH!
;***************************************************************
#include "ti86asm.inc"

.org _asm_exec_ram	;load the program into memory and exicute

 call _runindicoff	;turn off the run indicator
 ld ix,Pic			;point ix to location of the data
 call decompV		;decompress and display the pic...
 call _getkey		;wait for keypress



;********************************************************************
;if you are using this routine in your program, copy from here to....
;********************************************************************

ScrollLeft:
 ld b,128			;b = 128 (counts # of rotations of the screen)
Start:
 push bc			;hide b (for later) and c (not needed)

 ld hl,$FC0F		;point hl to the display memory (right edge)
 ld de,$20			;de = $20 (or 32 in decimal - 2 rows in the display memory)
 ld b,64			;b = 64 (counts rows down the screen)
loop1:
 push bc			;hide b (for later and c (for no reason)
 ld b,16			;b = 16 (yet another counter - across the screen)
 xor a				;clear a (a = 0)
 rla				;rotate a to the left one bit (clears the carry flag)
loop:
 ld a,(hl)			;what hl points to is now in a
 rla				;rotate a to the left one bit (bit 7 to cary flag and flag to bit 0)
 ld (hl),a			;store a back where it came from
 dec hl				;point hl to the previous byte
 djnz loop			;decrement b and loop if it's not zero (16 times)
 add hl,de			;point hl 20 bytes forward (next line)
 pop bc				;restore last push
 djnz loop1			;decrement b and loop if it's not zero (64 times)

 pop bc				;yet again
 djnz Start			;loop again 128 times
 ret				;return from the program (or a call)

;*********************************************************************
;copy to here and leave the "ret" to return from a call or the program
;*********************************************************************




;********************************************************
; -decompresses data that is vertically compressed with
; pic2db, by Levi Lansing
; -(decompresses data into the video memory - 1024 bytes)
; -ix=location of data to decompress
; -destroys- a,b,c,de,hl,ix (points to byte after data)
;********************************************************
decompV:
 xor a
 ld de,16
 ld hl,$FC00
decompLoop:
 ld a,(ix)
 cp $B7
 jr nz,DCnorm
 inc ix
 ld a,(ix)
 ld c,a
 inc ix
 ld a,(ix)
 ld b,a
 inc ix
DCrepeatLoop:
 ld (hl),c
 add hl,de
 jr nc,DCloop
 push de
 ld de,1022
 sbc hl,de
 pop de
 ld a,l
 cp $10
 jr nz,DCloop
 ret
DCloop:
 djnz DCrepeatLoop
 jr decompLoop
DCnorm:
 ld (hl),a
 inc ix
 add hl,de
 jr nc,decompLoop
 push de
 ld de,1022
 sbc hl,de
 pop de
 ld a,l
 cp $10
 jr nz,decompLoop
 ret
;***this decompression routine only costs 68 bytes for an average of 60-70%
;   compresion of a picture!***


;------data-------

Pic:		;data to copy to the screen as the picture

;Compressed picutre made with BMP to ASM by Levi Lansing (puzzlesome@hotmail.com)
;Compressed from 1024 bytes to 295 bytes - 71% compressed!
  .db $B7, $FF, $67, $00, $00, $B7, $3F, $06, $03, $03, $B7, $3F, $06, $00, $00, $B7
  .db $FF, $0A, $B7, $00, $04, $B7, $F8, $0E, $B7, $00, $04, $B7, $FF, $2A, $B7, $00
  .db $04, $B7, $1F, $0E, $B7, $00, $04, $B7, $FF, $0E, $00, $00, $B7, $3F, $06, $01
  .db $01, $B7, $3F, $08, $B7, $FF, $6E, $00, $00, $B7, $3F, $06, $01, $01, $B7, $3F
  .db $08, $B7, $FF, $0C, $B7, $3F, $10, $00, $00, $FF, $FF, $FF, $FC, $C0, $00, $87
  .db $B7, $FF, $29, $FE, $FE, $B7, $FC, $0A, $FE, $FE, $7F, $7F, $FF, $FF, $03, $00
  .db $1C, $7F, $B7, $FF, $0A, $00, $00, $B7, $3F, $06, $03, $03, $B7, $3F, $06, $00
  .db $00, $B7, $FF, $0C, $83, $01, $38, $7C, $B7, $FE, $09, $7E, $7C, $38, $01, $83
  .db $FF, $FF, $FF, $7F, $0F, $80, $F0, $B7, $FF, $0B, $FE, $FE, $FE, $B7, $FC, $08
  .db $FE, $FE, $FE, $B7, $FF, $0E, $B7, $FE, $04, $7E, $B7, $7F, $09, $B7, $FF, $06
  .db $FC, $F8, $E0, $00, $03, $B7, $FF, $09, $83, $01, $38, $7C, $7C, $B7, $FF, $08
  .db $FC, $7C, $38, $01, $83, $B7, $FF, $0C, $B7, $7C, $04, $78, $38, $39, $39, $39
  .db $31, $B7, $93, $04, $83, $C7, $C7, $C7, $FF, $80, $00, $0F, $7F, $B7, $FF, $0B
  .db $F8, $F8, $B7, $FF, $2F, $0F, $01, $E0, $FC, $B7, $FF, $0B, $00, $00, $B7, $CF
  .db $10, $B7, $FF, $0C, $00, $00, $B7, $3F, $06, $03, $03, $B7, $3F, $06, $00, $00
  .db $FF, $FF, $F9, $60, $00, $03, $B7, $FF, $0A, $7F, $7F, $B7, $FE, $05, $B7, $FF
  .db $06, $FE, $FC, $FE, $B7, $FF, $30, $83, $01, $38, $7D, $7F, $7F, $3F, $0F, $87
  .db $E1, $F1, $F8, $FC, $FC, $7C, $39, $01, $87, $B7, $FF, $2E, $B7, $FC, $0D, $FF
  .db $FF, $FC, $FC, $FC, $B7, $FF, $47

.end
